#ifndef __BUTTON_HPP__
#define __BUTTON_HPP__

#include <stdint.h>

class Button {
private:
protected:
	uint8_t _pin;
public:
	Button(uint8_t pin): _pin{pin} {};
	~Button() {};

	int setup(void);
	bool is_button_pressed(void);
};

class AnalogButton: Button {
public:
	AnalogButton(uint8_t pin, int vRef=-1) : _vRef{vRef}, Button(pin) {};
	virtual ~AnalogButton();
	bool is_button_pressed(void);
	void calibrate(void);
private:
	int _vRef;
};

#endif /* __BUTTON_HPP__ */
