#include "led_strip.hpp"

// LedStrip::LedStrip(/* args */) {}
// LedStrip::~LedStrip() {}

#if defined(ARDUINO_AVR_ATTINYX5) || defined(ARDUINO_AVR_ATTINYX41)
/* TODO: remove when switching to tinycore V2.0.0 */
void LedStrip::fill(uint32_t c, uint16_t first, uint16_t count) {
  uint16_t i, end;

  if (first >= LedCount) {
    return; // If first LED is past end of strip, nothing to do
  }

  // Calculate the index ONE AFTER the last pixel to fill
  if (count == 0) {
    // Fill to end of strip
    end = LedCount;
  } else {
    // Ensure that the loop won't go past the last pixel
    end = first + count;
    if (end > LedCount)
      end = LedCount;
  }

  for (i = first; i < end; i++) {
    ledRing.setPixelColor(i, c);
  }
}

int LedStrip::setup() {
  pinMode(LedPin, OUTPUT);
  ledRing.setPixelColor(0, 255, 0, 0);
  fill(tinyNeoPixel::Color(45, 0, 0));
  ledRing.show();
  delay(300);
  fill(tinyNeoPixel::Color(0, 45, 0));
  ledRing.show();
  delay(300);
  fill(tinyNeoPixel::Color(0, 0, 45));
  ledRing.show();
  delay(300);
  return 0;
}

#else

int LedStrip::setup() {
  ledRing.begin();
  ledRing.fill(Adafruit_NeoPixel::Color(45, 0, 0));
  delay(300);
  ledRing.fill(Adafruit_NeoPixel::Color(0, 45, 0));
  delay(300);
  ledRing.fill(Adafruit_NeoPixel::Color(0, 0, 45));
  delay(300);
  return 0;
}

#endif /* defined(ARDUINO_AVR_ATTINYX5) || defined(ARDUINO_AVR_ATTINYX41) */